/* Tabela RESPOSINSPEC*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RESPOSINSPEC*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela RESPOSINSPEC, utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_RESPOSINSPEC' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_RESPOSINSPEC
GO
CREATE TRIGGER LOG_CDP_RESPOSINSPEC
ON RESPOSINSPEC
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDINSPECAO_NEW    VARCHAR(10);
  DECLARE @V_CDRESPINSPEC_NEW  VARCHAR(05);
  DECLARE @V_NMRESPINSPEC_NEW  VARCHAR(50);
  DECLARE @V_IDFAIXRESINS_NEW  VARCHAR(01);
  DECLARE @V_VRINIFAIXRES_NEW  DOUBLE PRECISION;
  DECLARE @V_VRFINFAIXRES_NEW  DOUBLE PRECISION;
  DECLARE @V_VRPONTRESINS_NEW  DOUBLE PRECISION;
  DECLARE @V_CDPRODUTO_NEW     VARCHAR(10);
  DECLARE @V_SGUNIDADE_NEW     VARCHAR(10);
  DECLARE @V_IDRESPPROC_NEW    VARCHAR(01);
  DECLARE @V_IDSTATUSRESP_NEW  VARCHAR(01);
  DECLARE @V_DTINIFAIXRES_NEW  DATE;
  DECLARE @V_DTFINFAIXRES_NEW  DATE;
  DECLARE @V_DTULTATURINS_NEW  DATE;

  DECLARE @V_CDINSPECAO_OLD    VARCHAR(10);
  DECLARE @V_CDRESPINSPEC_OLD  VARCHAR(05);
  DECLARE @V_NMRESPINSPEC_OLD  VARCHAR(50);
  DECLARE @V_IDFAIXRESINS_OLD  VARCHAR(01);
  DECLARE @V_VRINIFAIXRES_OLD  DOUBLE PRECISION;
  DECLARE @V_VRFINFAIXRES_OLD  DOUBLE PRECISION;
  DECLARE @V_VRPONTRESINS_OLD  DOUBLE PRECISION;
  DECLARE @V_CDPRODUTO_OLD     VARCHAR(10);
  DECLARE @V_SGUNIDADE_OLD     VARCHAR(10);
  DECLARE @V_IDRESPPROC_OLD    VARCHAR(01);
  DECLARE @V_IDSTATUSRESP_OLD  VARCHAR(01);
  DECLARE @V_DTINIFAIXRES_OLD  DATE;
  DECLARE @V_DTFINFAIXRES_OLD  DATE;
  DECLARE @V_DTULTATURINS_OLD  DATE;


   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO = '-';


   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL,
         CDINSPECAO,
         CDRESPINSPEC,
         NMRESPINSPEC,
         IDFAIXRESINS,
         VRINIFAIXRES,
         VRFINFAIXRES,
         VRPONTRESINS,
         CDPRODUTO,
         SGUNIDADE,
         IDRESPPROC,
         IDSTATUSRESP,
         DTINIFAIXRES,
         DTFINFAIXRES,
         DTULTATURINS
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDINSPECAO,
         INSERTED.CDRESPINSPEC,
         INSERTED.NMRESPINSPEC,
         INSERTED.IDFAIXRESINS,
         INSERTED.VRINIFAIXRES,
         INSERTED.VRFINFAIXRES,
         INSERTED.VRPONTRESINS,
         INSERTED.CDPRODUTO,
         INSERTED.SGUNIDADE,
         INSERTED.IDRESPPROC,
         INSERTED.IDSTATUSRESP,
         INSERTED.DTINIFAIXRES,
         INSERTED.DTFINFAIXRES,
         INSERTED.DTULTATURINS,

         DELETED.CDINSPECAO,
         DELETED.CDRESPINSPEC,
         DELETED.NMRESPINSPEC,
         DELETED.IDFAIXRESINS,
         DELETED.VRINIFAIXRES,
         DELETED.VRFINFAIXRES,
         DELETED.VRPONTRESINS,
         DELETED.CDPRODUTO,
         DELETED.SGUNIDADE,
         DELETED.IDRESPPROC,
         DELETED.IDSTATUSRESP,
         DELETED.DTINIFAIXRES,
         DELETED.DTFINFAIXRES,
         DELETED.DTULTATURINS

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDINSPECAO = DELETED.CDINSPECAO AND
         INSERTED.CDRESPINSPEC = DELETED.CDRESPINSPEC

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDINSPECAO,
         INSERTED.CDRESPINSPEC,
         INSERTED.NMRESPINSPEC,
         INSERTED.IDFAIXRESINS,
         INSERTED.VRINIFAIXRES,
         INSERTED.VRFINFAIXRES,
         INSERTED.VRPONTRESINS,
         INSERTED.CDPRODUTO,
         INSERTED.SGUNIDADE,
         INSERTED.IDRESPPROC,
         INSERTED.IDSTATUSRESP,
         INSERTED.DTINIFAIXRES,
         INSERTED.DTFINFAIXRES,
         INSERTED.DTULTATURINS,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_R;
   FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                   @V_CDINSPECAO_NEW, @V_CDRESPINSPEC_NEW, @V_NMRESPINSPEC_NEW, @V_IDFAIXRESINS_NEW, @V_VRINIFAIXRES_NEW,
                                   @V_VRFINFAIXRES_NEW, @V_VRPONTRESINS_NEW, @V_CDPRODUTO_NEW, @V_SGUNIDADE_NEW, @V_IDRESPPROC_NEW,
                                   @V_IDSTATUSRESP_NEW, @V_DTINIFAIXRES_NEW, @V_DTFINFAIXRES_NEW, @V_DTULTATURINS_NEW,

                                   @V_CDINSPECAO_OLD, @V_CDRESPINSPEC_OLD, @V_NMRESPINSPEC_OLD, @V_IDFAIXRESINS_OLD, @V_VRINIFAIXRES_OLD,
                                   @V_VRFINFAIXRES_OLD, @V_VRPONTRESINS_OLD, @V_CDPRODUTO_OLD, @V_SGUNIDADE_OLD, @V_IDRESPPROC_OLD,
                                   @V_IDSTATUSRESP_OLD, @V_DTINIFAIXRES_OLD, @V_DTFINFAIXRES_OLD, @V_DTULTATURINS_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_TIPO = 'D' BEGIN
         IF @V_CDINSPECAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Inspeo = ' + ISNULL(@V_CDINSPECAO_OLD,'') + ' ';
         END;
         IF @V_CDRESPINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo Resposta = ' + ISNULL(@V_CDRESPINSPEC_OLD,'') + ' ';
         END;
         IF @V_NMRESPINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Resposta = ' + ISNULL(@V_NMRESPINSPEC_OLD,'') + ' ';
         END;
         IF @V_IDFAIXRESINS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tipo Faixa = ' + ISNULL(@V_IDFAIXRESINS_OLD,'') + ' ';
         END;
         IF @V_VRINIFAIXRES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Faixa Inicial = ' + ISNULL(CONVERT(VARCHAR,@V_VRINIFAIXRES_OLD),'') + ' ';
         END;
         IF @V_VRFINFAIXRES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Faixa Final = ' + ISNULL(CONVERT(VARCHAR,@V_VRFINFAIXRES_OLD),'') + ' ';
         END;
         IF @V_VRPONTRESINS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Pontuao = ' + ISNULL(CONVERT(VARCHAR,@V_VRPONTRESINS_OLD),'') + ' ';
         END;
         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Produto = ' + ISNULL(@V_CDPRODUTO_OLD,'') + ' ';
         END;
         IF @V_SGUNIDADE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Unidade = ' + ISNULL(@V_SGUNIDADE_OLD,'') + ' ';
         END;
         IF @V_IDRESPPROC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Processo = ' + ISNULL(@V_IDRESPPROC_OLD,'') + ' ';
         END;
         IF @V_IDSTATUSRESP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Status = ' + ISNULL(@V_IDSTATUSRESP_OLD,'') + ' ';
         END;
         IF @V_DTINIFAIXRES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Data Inicial = ' + ISNULL(CONVERT(VARCHAR, @V_DTINIFAIXRES_OLD),'') + ' ';
         END;
         IF @V_DTFINFAIXRES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Data Final = ' + ISNULL(CONVERT(VARCHAR,@V_DTFINFAIXRES_OLD),'') + ' ';
         END;
         IF @V_DTULTATURINS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ltima Alterao = ' + ISNULL(CONVERT(VARCHAR,@V_DTULTATURINS_OLD),'') + ' ';
         END;

         SET @V_TPMOVI = '3';
         SET @V_ITPESQ = @V_CDINSPECAO_OLD + @V_CDRESPINSPEC_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
            IF (@V_CDINSPECAO_OLD   <> @V_CDINSPECAO_NEW) OR
               (@V_CDRESPINSPEC_OLD <> @V_CDRESPINSPEC_NEW)     OR
               (@V_NMRESPINSPEC_OLD <> @V_NMRESPINSPEC_NEW) OR
               (@V_IDFAIXRESINS_OLD <> @V_IDFAIXRESINS_NEW) OR
               (@V_VRINIFAIXRES_OLD <> @V_VRINIFAIXRES_NEW) OR
               (@V_VRFINFAIXRES_OLD <> @V_VRFINFAIXRES_NEW)     OR
               (@V_VRPONTRESINS_OLD <> @V_VRPONTRESINS_NEW) OR
               (@V_CDPRODUTO_OLD    <> @V_CDPRODUTO_NEW) OR
               (@V_SGUNIDADE_OLD    <> @V_SGUNIDADE_NEW) OR
               (@V_IDRESPPROC_OLD   <> @V_IDRESPPROC_NEW)     OR
               (@V_IDSTATUSRESP_OLD <> @V_IDSTATUSRESP_NEW) OR
               (@V_DTINIFAIXRES_OLD <> @V_DTINIFAIXRES_NEW) OR
               (@V_DTFINFAIXRES_OLD <> @V_DTFINFAIXRES_NEW) OR
               (@V_DTULTATURINS_OLD <> @V_DTULTATURINS_NEW) BEGIN

               SET @V_TPMOVI = '2';
               SET @V_ITPESQ = @V_CDINSPECAO_OLD + @V_CDRESPINSPEC_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI = '1';
            SET @V_ITPESQ = @V_CDINSPECAO_NEW + @V_CDRESPINSPEC_NEW;
         END;

         IF ISNULL(@V_CDINSPECAO_NEW, '!') <> ISNULL(@V_CDINSPECAO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Inspeo =' + @V_CDINSPECAO_NEW;
         END;

         IF ISNULL(@V_CDRESPINSPEC_NEW, '!') <> ISNULL(@V_CDRESPINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Cdigo Resposta = ' + @V_CDRESPINSPEC_NEW;
         END;

         IF ISNULL(@V_NMRESPINSPEC_NEW, '!') <> ISNULL(@V_NMRESPINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Resposta = ' + @V_NMRESPINSPEC_NEW;
         END;

         IF ISNULL(@V_IDFAIXRESINS_NEW, '!') <> ISNULL(@V_IDFAIXRESINS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tipo Faixa = ' + @V_IDFAIXRESINS_NEW;
         END;

         IF ISNULL(@V_VRINIFAIXRES_NEW, '!') <> ISNULL(@V_VRINIFAIXRES_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Faixa Inicial = ' + CONVERT(VARCHAR,@V_VRINIFAIXRES_NEW);
         END;

         IF ISNULL(@V_VRFINFAIXRES_NEW, '!') <> ISNULL(@V_VRFINFAIXRES_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Faixa Final = ' + CONVERT(VARCHAR,@V_VRFINFAIXRES_NEW);
         END;

         IF ISNULL(@V_VRPONTRESINS_NEW, '!') <> ISNULL(@V_VRPONTRESINS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Pontuao = ' + CONVERT(VARCHAR,@V_VRPONTRESINS_NEW);
         END;

         IF ISNULL(@V_CDPRODUTO_NEW, '!') <> ISNULL(@V_CDPRODUTO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Produto = ' + @V_CDPRODUTO_NEW;
         END;

         IF ISNULL(@V_SGUNIDADE_NEW, '!') <> ISNULL(@V_SGUNIDADE_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Unidade = ' + @V_SGUNIDADE_NEW;
         END;

         IF ISNULL(@V_IDRESPPROC_NEW, '!') <> ISNULL(@V_IDRESPPROC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Processo = ' + @V_IDRESPPROC_NEW;
         END;

         IF ISNULL(@V_IDSTATUSRESP_NEW, '!') <> ISNULL(@V_IDSTATUSRESP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Status = ' + @V_IDSTATUSRESP_NEW;
         END;

         IF ISNULL(CONVERT(VARCHAR,@V_DTINIFAIXRES_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTINIFAIXRES_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Data Inicial = ' + CONVERT(VARCHAR,@V_DTINIFAIXRES_NEW);
         END;

         IF ISNULL(CONVERT(VARCHAR,@V_DTFINFAIXRES_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTFINFAIXRES_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Data Final = ' + CONVERT(VARCHAR,@V_DTFINFAIXRES_NEW);
         END;

         IF ISNULL(CONVERT(VARCHAR,@V_DTULTATURINS_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTULTATURINS_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'ltima Alterao = ' + CONVERT(VARCHAR,@V_DTULTATURINS_NEW);
         END;
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN

            SET @V_DTOPER = GETDATE();

            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                CDPESQITEM,
                DSOPERACAO,
                CDFILLOGOPER,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('RESPOSINSPEC',
                @V_DTOPER,
                @V_USUARIO,
                @V_TPMOVI,
                @V_ITPESQ,
                SUBSTRING(@V_DESC,1,300),
                @V_CDFILLOGOPER,
                @V_DSSERVERRDM,
                @V_DSREMOTEADDR,
                @V_DSREMOTEHOST,
                @V_DSSERVMETHOD,
                @V_DSREMOTEOPER);

         END;
      END;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                      @V_CDINSPECAO_NEW, @V_CDRESPINSPEC_NEW, @V_NMRESPINSPEC_NEW, @V_IDFAIXRESINS_NEW, @V_VRINIFAIXRES_NEW,
                                      @V_VRFINFAIXRES_NEW, @V_VRPONTRESINS_NEW, @V_CDPRODUTO_NEW, @V_SGUNIDADE_NEW, @V_IDRESPPROC_NEW,
                                      @V_IDSTATUSRESP_NEW, @V_DTINIFAIXRES_NEW, @V_DTFINFAIXRES_NEW, @V_DTULTATURINS_NEW,

                                      @V_CDINSPECAO_OLD, @V_CDRESPINSPEC_OLD, @V_NMRESPINSPEC_OLD, @V_IDFAIXRESINS_OLD, @V_VRINIFAIXRES_OLD,
                                      @V_VRFINFAIXRES_OLD, @V_VRPONTRESINS_OLD, @V_CDPRODUTO_OLD, @V_SGUNIDADE_OLD, @V_IDRESPPROC_OLD,
                                      @V_IDSTATUSRESP_OLD, @V_DTINIFAIXRES_OLD, @V_DTFINFAIXRES_OLD, @V_DTULTATURINS_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_RESPOSINSPEC','6.05.XXX';
GO

